extends Spatial


var emitted = false
var source_position = Vector3()


func _ready():
	randomize()
	$Timer.connect("timeout", self, "on_timeout")
	$Missile.connect("body_entered", self, "on_body_entered")
	$Missile.connect("body_exited", self, "on_body_exited")


func on_timeout():
	
	if source_position and not emitted:
		print("Signal not emitted!")
		breakpoint
	
	$Target.transform = Transform.IDENTITY
	$Target.linear_velocity = Vector3(0.0, 0.0, 0.0)
	$Target.angular_velocity = Vector3(0.0, 0.0, 0.0)
	
	source_position = Vector3(-5.0, rand_range(-0.5, 0.5), rand_range(-0.5, 0.5))
	
	# This start position fails every time
	#source_position = Vector3(-5, -0.092388, -0.186422)
	
	print("Firing ball from: " + str(source_position))
	
	$Missile.transform.origin = source_position
	$Missile.transform.basis = Basis.IDENTITY
	$Missile.linear_velocity = Vector3(10.0, 0.0, 0.0)
	$Missile.angular_velocity = Vector3(0.0, 0.0, 0.0)
	
	emitted = false


func on_body_entered(var node : Node):
	emitted = true
	print("on_body_entered: " + node.name)


func on_body_exited(var node : Node):
	print("on_body_exited: " + node.name)
